config/routes.rb
Rails.application.routes.draw do
  # get 'search/people'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  root 'home#index'
  get 'home/index'

  resources :community_surveys do
    resources :houses do
      resources :family_folders do
        resources :house_health_surveys
        get '/people/search/:id', to: 'people#search'
        resources :people do
          resources :person_health_surveys
          resources :home_visits
        end
      end
    end
  end

  # Address
  get 'addr/update_amphur/:id', to: 'addresses#update_amphur'
  get 'addr/update_tambon/:id', to: 'addresses#update_tambon'

  # Authentication
  get '/login', to: 'sessions#new'
  post '/login', to: 'sessions#create'
  delete '/logout', to: 'sessions#destroy'

  get '/goto_house', to: 'home#house'
  get '/goto_house_health_survey', to: 'home#house_health_survey'
  get '/goto_person', to: 'home#person'
  get '/goto_person_health_survey', to: 'home#person_health_survey'
  get '/goto_home_visit', to: 'home#home_visit'

  get 'communities/search', to: 'community_surveys#search_main'
  resources :diseases

  # Report
  # resources :reports
  # get '/reports', to: 'reports#community_survey'
  get '/reports/overall', to: 'reports#overall'
  get '/reports/community', to: 'reports#community_survey'
  get '/reports/admin/health_survey', to: 'reports#admin_health_survey'
  get '/reports/admin/home_visit', to: 'reports#admin_home_visit'
  get '/reports/admin/houses', to: 'reports#admin_houses'
  get '/reports/admin/people', to: 'reports#admin_people'
  get '/reports/site/health_survey', to: 'reports#site_health_survey'
  get '/reports/site/home_visit', to: 'reports#site_home_visit'
  get '/reports/site/houses', to: 'reports#site_houses'
  get '/reports/site/people', to: 'reports#site_people'

  get '/hospitals', to: 'hospitals#search'
  get '/hospitals/type/:id', to: 'hospitals#by_type'

  # Search
  # get '/search', to: 'search#search_people'
  # Test
  get '/search', to: 'search#people'
end

app/controllers/search_controller.rb
class SearchController < ApplicationController
  # skip_before_action :authenticate_user!, only: [:people]

  # def search_people
  #   persons = Person.includes([:house])
  #                   .where(hospcode: current_user.hospcode)
  #                   .where(
  #                     "
  #                       first_name SIMILAR TO :value
  #                       OR last_name SIMILAR TO :value
  #                       OR pid SIMILAR TO :value
  #                     ",
  #                     value: "%(#{request.params["value"].split(' ').collect(&:strip).join("|")})%"
  #                   ) if request.params["personId"].blank?
  #   persons = Person.includes(:house)
  #                   .where(person_id: request.params["personId"])
  #                   .where(hospcode: current_user.hospcode) unless request.params["personId"].blank?
  #   @length = persons.length
  #   @results = persons.page page_param

  #   respond_to do |format|
  #     format.html { render 'search/index' }
  #     format.json
  #     # { render json: persons.as_json(include: { house: { include: %i[community_survey addr_tambon addr_amphur addr_changwat] } }) }
  #   end
  # end

  def people
    @persons = Person.joins(house: :community_survey).where(
      'people.hospcode = :hospcode and (first_name like :value or last_name like :value or pid like :value)',
      { hospcode: current_user.hospcode, value: "#{params['value']}%" }
    )
    respond_to do |format|
      format.html { render 'search/index' }
      format.json
    end
  end
end

app/views/search/index.html.erb
<div class="container --search">
  <% if @results.length != 0 %>
    <p class="header-sub"><%= t("search_result_all_label") %> <%= @length %> <%= t("list_label") %></p>
    <table class="ui table">
      <thead>
        <tr>
          <th class=""><%= t("community_survey.vname_label") %></th>
          <th><%= t("house.house_label") %></th>
          <th><%= t("family_folder.family_label") %></th>
          <th colspan="2"><%= t("person.title_label") %></th>
        </tr>
      </thead>
      <tbody>
        <% @results.each do | item | %>
        <%
          house = House.find(item.house_id)
          community_survey = CommunitySurvey.find(house.community_survey_id)
        %>
          <tr>
            <td>
              <%= link_to community_surveys_path(vid: community_survey.id, value: params[:value]), target: :_blank do %>
                <%= community_survey.vname %>
              <% end %>
            </td>
            <td>
              <%= link_to community_survey_houses_path(community_survey.id, hid: house.id, value: params[:value]), target: :_blank do %>
                <%= house.house %>
              <% end %>
            </td>
            <td>
              <%= link_to community_survey_house_family_folders_path(community_survey.id, house.id, family_folder_id: item.family_folder_id, value: params[:value]), target: :_blank do %>
                <%= item.family_folder_id %>
              <% end %>
            </td>
            <td>
              <%= link_to community_survey_house_family_folder_people_path(community_survey.id, house.id, item.family_folder_id, person_id: item.person_id, value: params[:value]), target: :_blank do %>
                <%= item.first_name %> <%= item.last_name %>
                <% if item.pid.present? %>
                  <div class="sub header"><%= t("cid_label") %> <%= item.pid %></div>
                <% end %>
              <% end %>
            </td>
            <td><%= link_to t('person_health_survey.title_label'), community_survey_house_family_folder_person_person_health_surveys_path(community_survey.id, house.id, item.family_folder_id, item.person_id, value: params[:value]), target: :_blank %>
              <%= link_to t('home_visit.title_label'), community_survey_house_family_folder_person_home_visits_path(community_survey.id, house.id, item.family_folder_id, item.person_id, value: params[:value]), target: :_blank %>
            </td>
          </tr>
        <% end %>
      </tbody>
    </table>
    <div class="pagination">
      <%= paginate @results %>
    </div>
  <% else %>
    <p class="header-sub"><%= t("your_search_label") %> "<%= request.params["value"] %>" <%= t("search_not_found_label") %></p>
  <% end %>
</div>
<% content_for :menu_content_title do %> 
  <div class="ui breadcrumb">
    <div class="active section"><%= t("search_result_label") %></div>
  </div>
<% end %>